=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

module Shippo
  class CarrierOwnAccountsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a new carrier account
    # Creates a new carrier account or connects an existing carrier account to the Shippo account.
    # @param [Hash] opts the optional parameters
    # @option opts [ConnectExistingOwnUPSAccountRequest] :body Examples.
    # @return [PlatformCarrierOwnAccountCreationResponse]
    def platform_carrier_own_account_creation(opts = {})
      data, _status_code, _headers = platform_carrier_own_account_creation_with_http_info(opts)
      data
    end

    # Create a new carrier account
    # Creates a new carrier account or connects an existing carrier account to the Shippo account.
    # @param [Hash] opts the optional parameters
    # @option opts [ConnectExistingOwnUPSAccountRequest] :body Examples.
    # @return [Array<(PlatformCarrierOwnAccountCreationResponse, Integer, Hash)>] PlatformCarrierOwnAccountCreationResponse data, response status code and response headers
    def platform_carrier_own_account_creation_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CarrierOwnAccountsApi.platform_carrier_own_account_creation ...'
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/carrier_accounts/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(opts[:'body']) 

      return_type = opts[:return_type] || 'PlatformCarrierOwnAccountCreationResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CarrierOwnAccountsApi#platform_carrier_own_account_creation\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all carrier accounts
    # List all carrier accounts.
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @option opts [Integer] :page description: The page number you want to select (default to 1)
    # @option opts [Integer] :results description: The number of results to return per page (max 100) (default to 25)
    # @return [PlatformCarrierOwnAccountListResponse]
    def platform_carrier_own_account_list(merchant_id, opts = {})
      data, _status_code, _headers = platform_carrier_own_account_list_with_http_info(merchant_id, opts)
      data
    end

    # List all carrier accounts
    # List all carrier accounts.
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @option opts [Integer] :page description: The page number you want to select
    # @option opts [Integer] :results description: The number of results to return per page (max 100)
    # @return [Array<(PlatformCarrierOwnAccountListResponse, Integer, Hash)>] PlatformCarrierOwnAccountListResponse data, response status code and response headers
    def platform_carrier_own_account_list_with_http_info(merchant_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CarrierOwnAccountsApi.platform_carrier_own_account_list ...'
      end
      # verify the required parameter 'merchant_id' is set
      if @api_client.config.client_side_validation && merchant_id.nil?
        fail ArgumentError, "Missing the required parameter 'merchant_id' when calling CarrierOwnAccountsApi.platform_carrier_own_account_list"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/carrier_accounts/'.sub('{' + 'MerchantId' + '}', merchant_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'results'] = opts[:'results'] if !opts[:'results'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'SHIPPO-API-VERSION'] = opts[:'shippo_api_version'] if !opts[:'shippo_api_version'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'PlatformCarrierOwnAccountListResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CarrierOwnAccountsApi#platform_carrier_own_account_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve a carrier account
    # Retrieve an existing carrier account by object id.
    # @param carrier_account_id description: Object ID of the carrier account
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @return [PlatformCarrierOwnAccountCreationResponse]
    def platform_carrier_own_account_get(carrier_account_id, merchant_id, opts = {})
      data, _status_code, _headers = platform_carrier_own_account_get_with_http_info(carrier_account_id, merchant_id, opts)
      data
    end

    # Retrieve a carrier account
    # Retrieve an existing carrier account by object id.
    # @param carrier_account_id description: Object ID of the carrier account
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @return [Array<(PlatformCarrierOwnAccountCreationResponse, Integer, Hash)>] PlatformCarrierOwnAccountCreationResponse data, response status code and response headers
    def platform_carrier_own_account_get_with_http_info(carrier_account_id, merchant_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CarrierOwnAccountsApi.platform_carrier_own_account_get ...'
      end
      # verify the required parameter 'carrier_account_id' is set
      if @api_client.config.client_side_validation && carrier_account_id.nil?
        fail ArgumentError, "Missing the required parameter 'carrier_account_id' when calling CarrierOwnAccountsApi.platform_carrier_own_account_get"
      end
      # verify the required parameter 'merchant_id' is set
      if @api_client.config.client_side_validation && merchant_id.nil?
        fail ArgumentError, "Missing the required parameter 'merchant_id' when calling CarrierOwnAccountsApi.platform_carrier_own_account_get"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/carrier_accounts/{CarrierAccountId}'.sub('{' + 'CarrierAccountId' + '}', carrier_account_id.to_s).sub('{' + 'MerchantId' + '}', merchant_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'SHIPPO-API-VERSION'] = opts[:'shippo_api_version'] if !opts[:'shippo_api_version'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'PlatformCarrierOwnAccountCreationResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CarrierOwnAccountsApi#platform_carrier_own_account_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update a carrier account
    # PUT request to update an existing carrier account object. The account_id and carrier can't be updated, because they form the unique identifier together.
    # @param [Hash] opts the optional parameters
    # @option opts [UpdateCarrierAccountRequest] :body Examples.
    # @return [PlatformCarrierOwnAccountCreationResponse]
    def platform_carrier_own_account_update(opts = {})
      data, _status_code, _headers = platform_carrier_own_account_update_with_http_info(opts)
      data
    end

    # Update a carrier account
    # PUT request to update an existing carrier account object. The account_id and carrier can&#x27;t be updated, because they form the unique identifier together.
    # @param [Hash] opts the optional parameters
    # @option opts [UpdateCarrierAccountRequest] :body Examples.
    # @return [Array<(PlatformCarrierOwnAccountCreationResponse, Integer, Hash)>] PlatformCarrierOwnAccountCreationResponse data, response status code and response headers
    def platform_carrier_own_account_update_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CarrierOwnAccountsApi.platform_carrier_own_account_update ...'
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/carrier_accounts/{CarrierAccountId}'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(opts[:'body']) 

      return_type = opts[:return_type] || 'PlatformCarrierOwnAccountCreationResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CarrierOwnAccountsApi#platform_carrier_own_account_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
